Page MenuHomePhabricator

Add a link engineering: Prototype the recommended link plugin in VisualEditor using phrase matching approach
Closed, ResolvedPublic

Description

As noted in T259035#6546455, we're going to operate on a list of phrases (plus some additional metadata) to locate text in VisualEditor's editable surface to present to the user as links.

This task should result in a prototype that is able to use a statically defined list of data (see the proposed structure in T259035#6546455 and T261411#6546055) to apply to a page in VE. I'm thinking we would have a page that we populate with text and a hook that exports the link recommendation metadata to the client-side. It would be nice to be able to easily adjust the fake data to manually verify our assumptions about how well the phrase matching approach will work.

The goal would be to be able to reuse most of the work done in prototyping for the final product as well.

Notes from @MMiller_WMF on 2020-10-29 about rough specifications (these are not solidified yet -- need about two more weeks):

These specifications track with the current interactive prototypes:

Here are the specifications:

  • "AI suggestions" is a third "mode" in the editor, in addition to "source" and "visual".
  • When the user is in "AI suggestions" mode...
    • ...the usual editing toolbar is not there -- it just says "AI suggestions".
    • ...the editing surface is disabled. No normal edits can be made.
    • ...the only kind of interaction the user can do is with the link suggestions cards and clicking the suggested links in the text to refocus their view.
    • ...the user can toggle to the other editing modes with the "pencil" icon in the upper right. "AI suggestions" is listed as a mode with the "bot" icon.
    • ...before toggling to another mode, the user gets a dialog asking if they want to discard their changes and switch, or cancel and keep going with the suggestions.

Related Objects

Event Timeline

@Catrope please fill in the description with more details of what you'd like to do, when you have a moment. Thanks!

Change 627505 had a related patch set uploaded (by Catrope; owner: Catrope):
[mediawiki/extensions/GrowthExperiments@master] [WIP] Sketch for add a link with VisualEditor

https://gerrit.wikimedia.org/r/627505

kostajh changed the task status from Open to Stalled.Oct 13 2020, 10:49 AM

Until we finalize the ideas about using offsets or not, let's pause on this prototyping.

kostajh changed the task status from Stalled to Open.Oct 15 2020, 1:42 PM
kostajh assigned this task to Catrope.
kostajh edited projects, added Growth-Team (Current Sprint); removed Growth-Team.

Per discussion yesterday, moving this into our current sprint.

kostajh renamed this task from Add a link engineering: Prototype using VisualEditor's data model libraries for rendering sections of wikitext to Add a link engineering: Prototype the recommended link plugin in VisualEditor using phrase matching approach.Oct 15 2020, 1:46 PM
kostajh updated the task description. (Show Details)
kostajh added a project: Add-Link.

@RHo and @MMiller_WMF I was just catching up on the standup video from yesterday; could you please add some notes here (or perhaps there are other tasks for desktkop/mobile concept A/B) that outline your requirements (e.g. you can't click anywhere aside from a recommended link), even knowing that those will change in the short term?

@kostajh @Catrope -- I've added rough specifications to the task description. We'll be going over the details in our deep dive meetings.

@Tgr I think this task should be resolved as the prototype is done (thank you @Catrope); we can merge the code and pick up the individual tasks later, sounds OK to you?

Change 627505 merged by jenkins-bot:
[mediawiki/extensions/GrowthExperiments@master] Add a link prototype with VisualEditor

https://gerrit.wikimedia.org/r/627505

@Tgr I think this task should be resolved as the prototype is done (thank you @Catrope); we can merge the code and pick up the individual tasks later, sounds OK to you?

Works for me.